<?php

namespace Btravel\Attribute;

use User;

class Attribute
{
    /**
     * $attribute object.
     */
    protected $attribute;
    /**
     * $attribute_category object.
     */
    protected $attribute_category;

    /**
     * Constructor.
     */
    public function __construct(\Btravel\Attribute\Interfaces\AttributeRepositoryInterface $attribute,
        \Btravel\Attribute\Interfaces\AttributeCategoryRepositoryInterface $attribute_category)
    {
        $this->attribute = $attribute;
        $this->attribute_category = $attribute_category;
    }

    /**
     * Returns count of attribute.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.attribute.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->attribute->pushCriteria(new \Litepie\Btravel\Repositories\Criteria\AttributeUserCriteria());
        }

        $attribute = $this->attribute->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('attribute::' . $view, compact('attribute'))->render();
    }
    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.attribute_category.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->attribute_category->pushCriteria(new \Litepie\Btravel\Repositories\Criteria\AttributeCategoryUserCriteria());
        }

        $attribute_category = $this->attribute_category->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('attribute::' . $view, compact('attribute_category'))->render();
    }
}
