<?php

namespace Btravel\Attribute\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Btravel\Attribute\Interfaces\AttributeCategoryRepositoryInterface;

class AttributeCategoryPublicController extends BaseController
{
    // use AttributeCategoryWorkflow;

    /**
     * Constructor.
     *
     * @param type \Btravel\AttributeCategory\Interfaces\AttributeCategoryRepositoryInterface $attribute_category
     *
     * @return type
     */
    public function __construct(AttributeCategoryRepositoryInterface $attribute_category)
    {
        $this->repository = $attribute_category;
        parent::__construct();
    }

    /**
     * Show attribute_category's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $attribute_categories = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();


        return $this->response->setMetaTitle(trans('$attribute::attribute_category.names'))
            ->view('attribute::attribute_category.index')
            ->data(compact('attribute_categories'))
            ->output();
    }


    /**
     * Show attribute_category.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $attribute_category = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->response->setMetaTitle($$attribute_category->name . trans('attribute::attribute_category.name'))
            ->view('attribute::attribute_category.show')
            ->data(compact('attribute_category'))
            ->output();
    }

}
