<?php

namespace Btravel\Attribute\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class AttributeTransformer extends TransformerAbstract
{
    public function transform(\Btravel\Attribute\Models\Attribute $attribute)
    {
        return [
            'id'                => $attribute->getRouteKey(),
            'key'               => [
                'public'    => $attribute->getPublicKey(),
                'route'     => $attribute->getRouteKey(),
            ], 
            'id'                => $attribute->id,
            'parent_id'         => $attribute->parent_id,
            'name'              => $attribute->name,
            'slug'              => $attribute->slug,
            'created_at'        => $attribute->created_at,
            'updated_at'        => $attribute->updated_at,
            'deleted_at'        => $attribute->deleted_at,
            'url'               => [
                'public'    => trans_url('attribute/'.$attribute->getPublicKey()),
                'user'      => guard_url('attribute/attribute/'.$attribute->getRouteKey()),
            ], 
            'status'            => trans('app.'.$attribute->status),
            'created_at'        => format_date($attribute->created_at),
            'updated_at'        => format_date($attribute->updated_at),
        ];
    }
}